/*
	$Id: AsciiConvertionMode.h,v 1.13 2003/05/14 12:03:14 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include <vector>
#include "CppCFString.h"
#include "BIM.h"
#include "InputMode.h"
#include "ChildInputMode.h"
#include "RegistrationStarter.h"
using namespace std;

class AsciiConvertionMode : public ChildInputMode , public RegistrationStarter
{
	protected:
		static const int STATUS_NULL = 0; // AXL[ϊ[hɂȂĂȂԁB擪ɁB
		static const int STATUS_WHITE = 1; // [h
		static const int STATUS_BLACK = 2; // [h
		static const int STATUS_BLACK_WITH_WINDOW = 3; // [hŁAIEChEJĂB
		static const int STATUS_PROMPT = 4; // vvgoĂB
		
		class WordRegisterMode* word_register_mode; // NULLłȂ͒Po^[hNB
		
		int status;
		CppCFString index; // o
		
		static const int PROMPT_DELETE_FROM_USER_DIC = 1; // [U[P폜
		int prompt_type; // vvg̎ށB
		CppCFString prompt; // vvg
		CppCFString prompt_input; // vvgɃ[U[͂
		
		vector<CppCFString> candidates; // SĂ̌
		unsigned current_candidate_index; // ݂̌ԍ
		
		unsigned show_cands_window_after_Nth_cand; // ڈȍ~̌IEChEɕ\邩B
		
		unsigned candidates_window_id; // statusSTATUS_BLACK_WITH_WINDOŴƂAIEChEIDB
		unsigned candidates_window_current_frame; // IEChĚ݂̃t[
		unsigned candidates_window_cands_per_frame; // IEChE1t[̌␔
		unsigned candidates_window_num_of_frames; // IEChẼt[
		
		bool completion_mode; // o⊮[hB̃[hł̓sIhƃJ}⊮̑ɎgB
		vector<CppCFString> completions; // ⊮̌
		unsigned current_completion_index; // ݂̕⊮̌ԍ
		
		bool henkanModeStatus;

		virtual void startRegisteringWord();
		virtual void askServerTheCandidates();
		virtual void askServerTheCompletions();
		virtual void makeServerRemoveWord();
		virtual void sendCurrentCandidateToServerToRegister();
		virtual void openCandidatesWindow();
		virtual void goToPrevCandidatesFrame();
		virtual void goToNextCandidatesFrame();
		virtual void closeCandidatesWindow();
		virtual void initialize();
	
	public:
		AsciiConvertionMode(class ParentInputMode& parent);
		virtual ~AsciiConvertionMode();
		
		virtual void start(); // ꂪĂ΂Ɓ[hɂȂB
		virtual bool handleInput(unsigned char inputChar);
		virtual bool handleBackSpace();
		virtual bool handleReturn();
		virtual bool handleArrow(int kind);
		virtual bool handleCg();
		virtual bool handleCy();
		virtual bool handleTab();
		virtual void terminate();
		virtual CppCFString getStringToDisplay();
		virtual CppCFString getStringToFix();
		
		virtual void wordRegistrationFinished(); // WordRegisterModepB
		virtual void wordRegistrationCanceled(); // WordRegisterModepB

	private:
		bool handleInputChar(unsigned char inputChar);
};
