/*
	$Id: BIMInputEvents.cpp,v 1.8 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define TARGET_API_MAC_CARBON 1

#include <Carbon/Carbon.h>
#include <string.h>
#include "BIM.h"
#include "BIMClientServer.h"
#include "BIMInputEvents.h"
#include "InputMode.h"

/*static void DumpInputBuffer(BIMSessionHandle session)
{
	for (unsigned i = 0;i < (*session)->fInputBufferCount;i++)
	{
		printf("0x%04x ",(*session)->fInputBuffer[i]);
	}
	printf("\n");
}*/

// CvbgGA̍XV
OSErr BIMUpdateActiveInputArea( BIMSessionHandle inSessionHandle, Boolean inFix )
{
	return BIMUpdateActiveInputAreaWithLength(inSessionHandle,inFix ?
						(*inSessionHandle)->fInputBufferCount * sizeof(UniChar) :
						0);
}

OSErr BIMUpdateActiveInputAreaWithLength( BIMSessionHandle inSessionHandle, long fixLength )
{
    OSErr error;
    EventRef event;
    ComponentInstance componentInstance;
    ScriptLanguageRecord scriptLanguageRecord;
    TextRange pinRange;
    TextRangeArrayPtr hiliteRangePtr;
    TextRangeArrayPtr updateRangePtr;

    hiliteRangePtr = nil;
    updateRangePtr = nil;
	
	// kCaret܂܂Ă邩ǂ𒲂ׁA܂܂Ă炻̈ʒuɃLbguB
	int caret_position = -1;
	for (unsigned i = 0;i < (*inSessionHandle)->fInputBufferCount;i++)
	{
		if ((*inSessionHandle)->fInputBuffer[i] == kCaret)
		{
			caret_position = i * sizeof(UniChar);
			
			//DumpInputBuffer(inSessionHandle);
			
			// ȍ~̕Oւ炵fInputBufferCount炷B
			for (unsigned j = i;j < (*inSessionHandle)->fInputBufferCount - 1;j++)
			{
				(*inSessionHandle)->fInputBuffer[j] = (*inSessionHandle)->fInputBuffer[j+1];
			}
			(*inSessionHandle)->fInputBufferCount--;
			
			//DumpInputBuffer(inSessionHandle);
			break;
		}
	}
	if (caret_position == -1)
	{
		caret_position = (*inSessionHandle)->fInputBufferCount * sizeof(UniChar);
	}
	
	// kEventClassTextInput/kEventTextInputUpdateActiveInputAreaCarbonCxg쐬
    error = CreateEvent( NULL, kEventClassTextInput, kEventTextInputUpdateActiveInputArea,
                         GetCurrentEventTime(), kEventAttributeUserEvent, &event );
	
    // ڂ̃p^̓R|[lgCX^Xւ̃|C^B
    if( error == noErr ) {
        componentInstance = (*inSessionHandle)->fComponentInstance;
        error = SetEventParameter( event, kEventParamTextInputSendComponentInstance,
                                   typeComponentInstance, sizeof( ComponentInstance ),
                                   &componentInstance );
    }

	// ڂ̃p^͌
    if( error == noErr ) {
        scriptLanguageRecord.fScript = smJapanese;			// smJapanese
        scriptLanguageRecord.fLanguage = langJapanese;		// langJapanese
        error = SetEventParameter( event, kEventParamTextInputSendSLRec,
                                   typeIntlWritingCode, sizeof( ScriptLanguageRecord ),
                                   &scriptLanguageRecord );
    }
	
	// XVeiUCS-32̔zj
    if( error == noErr )
        error = SetEventParameter( event, kEventParamTextInputSendText,
                                   typeUnicodeText,
                                   (*inSessionHandle)->fInputBufferCount * sizeof( UniChar ),
                                   (*inSessionHandle)->fInputBuffer );
	
	/*
		m肳镶ݒ肷B
		
		obt@̕0ȏȂfix
		OBIMUpdateActiveInputAreaWIthLength()ł̃obt@̕0ȏȂfix
		fixׂfix
		ȊOłfixȂBfixĂ܂CarbonAvőI𒆂̕sNB
	*/
    /*if( error == noErr &&
		((*inSessionHandle)->fInputBufferCount > 0 || (*inSessionHandle)->fLastUpdateLength > 0 || fixLength > 0))*/
	if( error == noErr &&
		((*inSessionHandle)->fInputBufferCount > 0 || (*inSessionHandle)->fLastUpdate > 0 || fixLength > 0))
	//if (error == noErr)
        error = SetEventParameter( event, kEventParamTextInputSendFixLen,
                                   typeLongInteger, sizeof( long ),
                                   &fixLength );

	// eLXgύXĂȂ΋̍XV̈nBȂΑSĂ̗̈XVB
    if( error == noErr ) {
        updateRangePtr = (TextRangeArrayPtr) NewPtrClear( sizeof( short ) + sizeof( TextRange ) * 2 );
		//updateRangePtr = (TextRangeArrayPtr) NewPtrClear( sizeof( short ) + sizeof( TextRange ) * 1 );
        if (updateRangePtr) {
            updateRangePtr->fNumOfRanges = 2;
            updateRangePtr->fRange [0].fStart = 0;
            updateRangePtr->fRange [0].fEnd = (*inSessionHandle)->fLastUpdateLength * sizeof( UniChar );
			//updateRangePtr->fRange [0].fEnd = 0;
            updateRangePtr->fRange [0].fHiliteStyle = 0;
            updateRangePtr->fRange [1].fStart = 0;
            updateRangePtr->fRange [1].fEnd = (*inSessionHandle)->fInputBufferCount * sizeof( UniChar );
            updateRangePtr->fRange [1].fHiliteStyle = 0;
			// updateRange͓pӂȂƁAEmacs̕ϊEChEoAvB
			// ̂B;y=[(߄t)E.@
			
			/*updateRangePtr->fNumOfRanges = 1;
			updateRangePtr->fRange[0].fStart = 0;
			updateRangePtr->fRange[1].fEnd = (*inSessionHandle)->fInputBufferCount * sizeof( UniChar );
			updateRangePtr->fRange[1].fHiliteStyle = 0;*/

			(*inSessionHandle)->fLastUpdate = (*inSessionHandle)->fInputBufferCount;
            (*inSessionHandle)->fLastUpdateLength = (*inSessionHandle)->fInputBufferCount;
        }
        else
            error = memFullErr;
    }

    if( error == noErr )
        error = SetEventParameter( event, kEventParamTextInputSendUpdateRng,
                                   typeTextRangeArray, sizeof( short ) + sizeof( TextRange ) * 2,
								   //typeTextRangeArray, sizeof( short ) + sizeof( TextRange ) * 1,
                                   updateRangePtr );

    // nCCg͈̔͂ƃLbg̈ʒuwB
    if( error == noErr )
	{
        hiliteRangePtr = (TextRangeArrayPtr) NewPtrClear (sizeof( short ) + sizeof( TextRange ) * 2);
        if( hiliteRangePtr )
		{
            hiliteRangePtr->fNumOfRanges = 2;
			
            hiliteRangePtr->fRange [0].fStart = 0;
            hiliteRangePtr->fRange [0].fEnd = (*inSessionHandle)->fInputBufferCount * sizeof( UniChar );
            if (fixLength > 0)
                hiliteRangePtr->fRange [0].fHiliteStyle = kConvertedText;
            else
                hiliteRangePtr->fRange [0].fHiliteStyle = kRawText;
			
            hiliteRangePtr->fRange [1].fStart = caret_position;
            hiliteRangePtr->fRange [1].fEnd = caret_position;
            hiliteRangePtr->fRange [1].fHiliteStyle = kCaretPosition;
        }
        else
		{
            error = memFullErr;
		}
    }
    if( error == noErr )
        error = SetEventParameter( event, kEventParamTextInputSendHiliteRng,
                                   typeTextRangeArray, sizeof( short ) + sizeof( TextRange ) * 2,
                                   hiliteRangePtr );

    pinRange.fStart = 0;
    pinRange.fEnd = (*inSessionHandle)->fInputBufferCount * sizeof( UniChar );
    if( error == noErr )
        error = SetEventParameter( event, kEventParamTextInputSendPinRng,
                                   typeTextRange, sizeof( TextRange ),
                                   &pinRange );

	// M
    if( error == noErr )
        error = SendTextInputEvent( event );
	
    DisposePtr( (Ptr) hiliteRangePtr );
    DisposePtr( (Ptr) updateRangePtr );
    return error;
}

// CvbgGÅe𓾂B
void BIMHandleOffsetToPos(struct OffsetToPosParams *offsetToPosParams)
{
	BIMHandleOffsetToPos(BIMGetActiveSession(),offsetToPosParams);
}
void BIMHandleOffsetToPos( BIMSessionHandle inSessionHandle,
                           struct OffsetToPosParams *offsetToPosParams )
{
    OSStatus		status;
    ComponentInstance	componentInstance;
    EventRef		event;
    
    event = NULL;

    // kEventClassTextInput/kEventTextInputUpdateActiveInputAreaCarbonCxg쐬
    status = CreateEvent( NULL, kEventClassTextInput, kEventTextInputOffsetToPos,
                          GetCurrentEventTime(), kEventAttributeUserEvent, &event );

    // ڂ̃p^̓R|[lgCX^Xւ̃|C^B
    if( status == noErr ) {
        componentInstance = (*inSessionHandle)->fComponentInstance;
        status = SetEventParameter( event, kEventParamTextInputSendComponentInstance,
                                    typeComponentInstance, sizeof( ComponentInstance ),
                                    &componentInstance );
    }
	
    // refConւ̃|C^n
    if( status == noErr )
        status = SetEventParameter( event, kEventParamTextInputSendRefCon, typeLongInteger,
                                    sizeof( long ), &offsetToPosParams->fRefCon );

    // eLXgItZbg̑
    if( status == noErr )
        status = SetEventParameter( event, kEventParamTextInputSendTextOffset, typeLongInteger,
                                    sizeof( long ), &offsetToPosParams->fTextOffset );

    // ݒ
    if( status == noErr )
        status = SetEventParameter( event, kEventParamTextInputSendSLRec, typeIntlWritingCode,
                                    sizeof( ScriptLanguageRecord ), &offsetToPosParams->fSLRec );

    // leading edgȇiIvVj
    if( status == noErr )
        status = SetEventParameter( event, kEventParamTextInputSendLeadingEdge, typeBoolean,
                                    sizeof( Boolean ), &offsetToPosParams->fLeadingEdge );

	// M
    if( status == noErr )
        status = SendTextInputEvent( event );

	// ʒuQDO[oW擾
    if( status == noErr )
        status = GetEventParameter( event, kEventParamTextInputReplyPoint, typeQDPoint, NULL,
                                    sizeof( Point ), NULL, &offsetToPosParams->fReplyPoint );
                                    
	// ݒ擾
    if( status == noErr ) {
        status = GetEventParameter( event, kEventParamTextInputReplySLRec, typeIntlWritingCode,
                                    NULL, sizeof( ScriptLanguageRecord ), NULL,
                                    &offsetToPosParams->fReplySLRec );
        if( status == eventParameterNotFoundErr ) {
            status = noErr;
            offsetToPosParams->fReplySLRecSpecified = TRUE;
        }
        else
            offsetToPosParams->fReplySLRecSpecified = FALSE;
    }
	
	// tHg擾iIvVj
    if( status == noErr ) {
        status = GetEventParameter( event, kEventParamTextInputReplyFont, typeLongInteger,
                                    NULL, sizeof( long ), NULL,
                                    &offsetToPosParams->fReplyFont );
        if( status == eventParameterNotFoundErr ) {
            status = noErr;
            offsetToPosParams->fReplyFontSpecified = TRUE;
        }
        else
            offsetToPosParams->fReplyFontSpecified = FALSE;
    }
                                    
	// TCY擾iIvVj
    if( status == noErr ) {
        status = GetEventParameter( event, kEventParamTextInputReplyPointSize, typeFixed,
                                    NULL, sizeof( Fixed ), NULL,
                                    &offsetToPosParams->fReplyPointSize );
        if( status == eventParameterNotFoundErr ) {
            status = noErr;
            offsetToPosParams->fReplyPointSizeSpecified = TRUE;
        }
        else
            offsetToPosParams->fReplyPointSizeSpecified = FALSE;
    }
                                    
    // s̍擾iIvVj
    if( status == noErr ) {
        status = GetEventParameter( event, kEventParamTextInputReplyLineHeight,
                                    typeShortInteger, NULL, sizeof( short ), NULL,
                                    &offsetToPosParams->fReplyLineHeight );
        if( status == eventParameterNotFoundErr ) {
            status = noErr;
            offsetToPosParams->fReplyLineHeightSpecified = TRUE;
        }
        else
            offsetToPosParams->fReplyLineHeightSpecified = FALSE;
    }
	
	// AZgC擾iIvVj
    if( status == noErr ) {
        status = GetEventParameter( event, kEventParamTextInputReplyLineAscent,
                                    typeShortInteger, NULL, sizeof( short ), NULL,
                                    &offsetToPosParams->fReplyLineAscent );
        if( status == eventParameterNotFoundErr ) {
            status = noErr;
            offsetToPosParams->fReplyLineAscentSpecified = TRUE;
        }
        else
            offsetToPosParams->fReplyLineAscentSpecified = FALSE;
    }
                                    
	// eLXg̉]擾iIvVj
    if( status == noErr ) {
        status = GetEventParameter( event, kEventParamTextInputReplyTextAngle, typeFixed,
                                    NULL, sizeof( Fixed ), NULL,
                                    &offsetToPosParams->fReplyTextAngle );
        if( status == eventParameterNotFoundErr ) {
            status = noErr;
            offsetToPosParams->fReplyTextAngleSpecified = TRUE;
        }
        else
            offsetToPosParams->fReplyTextAngleSpecified = FALSE;
    }

    if( event )
        ReleaseEvent( event );

    offsetToPosParams->fReplyResultCode = status;
}

/*
    CC͂ȂƂɕ\t[eBOEBhEB
*/
OSErr BIMHandleHideWindow( BIMSessionHandle inSessionHandle )
{
    OSErr error;
    ComponentInstance	componentInstance;
	ScriptLanguageRecord scriptLanguageRecord;
    EventRef		event;
    Boolean			showBottomWindow = false;
    event = NULL;

	// kEventClassTextInput/kEventTextInputShowHideBottomWindowCarbonCxg쐬
    error = CreateEvent( NULL, kEventClassTextInput, kEventTextInputShowHideBottomWindow,
                          GetCurrentEventTime(), kEventAttributeUserEvent, &event );

    // ڂ̃p^̓R|[lgCX^Xւ̃|C^B
    if( error == noErr ) {
        componentInstance = (*inSessionHandle)->fComponentInstance;
        error = SetEventParameter( event, kEventParamTextInputSendComponentInstance,
                                   typeComponentInstance, sizeof( ComponentInstance ),
                                   &componentInstance );
    }

	// ڂ̃p^͌
    if( error == noErr ) {
        scriptLanguageRecord.fScript = smJapanese;			// smJapanese
        scriptLanguageRecord.fLanguage = langJapanese;		// langJapanese
        error = SetEventParameter( event, kEventParamTextInputSendSLRec,
                                   typeIntlWritingCode, sizeof( ScriptLanguageRecord ),
                                   &scriptLanguageRecord );
    }
    
    if( error == noErr )
        error = SetEventParameter( event, kEventParamTextInputSendShowHide,
                                typeBoolean, sizeof( Boolean ),
                                &showBottomWindow );
    
	if( error == noErr )
        error = SendTextInputEvent( event );

	return error;
}
