/*
	$Id: CandidatesWindowController.mm,v 1.5 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "CandidatesWindowController.h"
#import "CandidatesView.h"
#import "PreferencesController.h"

@implementation CandidatesWindowController

- initWithCandidates:(NSArray*)cands
{
	self = [super initWithWindowNibName:@"Candidates"];
	[self window]; // load now
	
	self->candidates = [[NSArray alloc] initWithArray:cands];
	
	[[self window]
		setBackgroundColor:
            [[PreferencesController sharedController] windowColor]];
    
    [[self window]
		setAlphaValue:
            [[PreferencesController sharedController] windowAlpha]];
	
	self->candidates_view = [[CandidatesView alloc] initWithCandidates:cands];
	[[self window] setContentSize:[candidates_view bounds].size]; // candidates_view̃TCYɐݒB
	[[[self window] contentView] addSubview:candidates_view]; // EChEɒuB
	
	[[self window] setLevel:NSFloatingWindowLevel];
	
	return self;
}

- (NSArray*)getCandidates
{
	return candidates;
}

- (void)dealloc
{

}

- (void)showNextFrame
{
	[candidates_view showNextFrame];
}

- (void)showPrevFrame
{
	[candidates_view showPrevFrame];
}

- (unsigned)getCandidatesPerFrame
{
	return [candidates_view getCandidatesPerFrame];
}

- (unsigned)getNumOfFrames
{
	return [candidates_view getNumOfFrames];
}

@end
