/*
	$Id: ClientConfiguration.cpp,v 1.3 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "ClientConfiguration.h"
#include "ServerConnectionFactory.h"
#include "ServerConnection.h"
#include "BIMClientServer.h"
#include "CppCFData.h"

static ClientConfiguration* _shared_instance = NULL;

ClientConfiguration& ClientConfiguration::sharedConfiguration()
{
	if (_shared_instance == NULL)
	{
		_shared_instance = new ClientConfiguration();
	}
	return *_shared_instance;
}

ClientConfiguration::ClientConfiguration()
	:initialized(false)
{

}

ClientConfiguration::~ClientConfiguration()
{

}

void ClientConfiguration::initialize()
{
	// ɏĂ牽ȂB
	if (initialized) return;
	
	// skkEggLikeNewline
	CppCFData result = ServerConnectionFactory::sharedFactory().newConnection().send(kBasicMessageIsSkkEggLikeNewline);
	if (result.getLength() == sizeof(bool))
	{
		// Ԃꂽl͑낤B
		result.copyData(0,sizeof(bool),&skkEggLikeNewline);
	}
	else
	{
		skkEggLikeNewline = false;
	}
	
	initialized = true;
}

ClientConfiguration& ClientConfiguration::reloadConfiguration()
{
	// initializedtOĂinitialize();sB
	initialized = false;
	initialize();
	return *this;
}

bool ClientConfiguration::isSkkEggLikeNewline()
{
	initialize();
	return skkEggLikeNewline;
}
