/*
	$Id: ClientConnectionFactory.cpp,v 1.2 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "ClientConnectionFactory.h"
#include "BIMClientServer.h"

static ClientConnectionFactory* _shared_instance = NULL;

ClientConnectionFactory& ClientConnectionFactory::sharedFactory()
{
	if (_shared_instance == NULL)
	{
		_shared_instance = new ClientConnectionFactory();
	}
	return *_shared_instance;
}

ClientConnectionFactory::ClientConnectionFactory()
{
	default_target.highLongOfPSN = 0;
    default_target.lowLongOfPSN = kNoProcess;
}

ClientConnectionFactory::~ClientConnectionFactory()
{
	
}

ClientConnectionFactory& ClientConnectionFactory::setDefaultTarget(const ProcessSerialNumber& psn_of_target)
{
	default_target = psn_of_target;
	return *this;
}

CppCFString ClientConnectionFactory::generateClientPortName(const ProcessSerialNumber& psn_of_target)
{
	// vZXVAio[|[g쐬BAvԂŏdȂׂłB
	CFMutableStringRef portName;
    CFStringRef processSerialNumberStringRef;
    Str255 processSerialNumberString;
    Str255 processSerialNumberLowString;
	
    NumToString( psn_of_target.highLongOfPSN, processSerialNumberString );
    NumToString( psn_of_target.lowLongOfPSN, processSerialNumberLowString );
    BlockMoveData( processSerialNumberLowString + 1,
                   processSerialNumberString + processSerialNumberString [0] + 1,
                   processSerialNumberLowString [0] );
    processSerialNumberString [0] += processSerialNumberLowString [0];
	
    portName = CFStringCreateMutableCopy( NULL, 255, CFSTR( kBasicServerPortName ) );
    processSerialNumberStringRef = CFStringCreateWithPascalString( NULL,
                                                                   processSerialNumberString,
                                                                   CFStringGetSystemEncoding() );
    CFStringAppend( portName, processSerialNumberStringRef );
    CFRelease( processSerialNumberStringRef );
    return CppCFString(portName);
}

CppMessagePortConnection ClientConnectionFactory::newConnection() const
{
	return CppMessagePortConnection(generateClientPortName(default_target));
}

CppMessagePortConnection ClientConnectionFactory::newConnection(const ProcessSerialNumber& psn_of_target) const
{
	return CppMessagePortConnection(generateClientPortName(psn_of_target));
}
