/*
	$Id: CppCFData.h,v 1.5 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>

// CFMutableDataRef̃bp[B

class CppCFData
{
	protected:
		CFMutableDataRef cf_data;
	
	public:
		CppCFData();
		CppCFData(CFDataRef copy_source);
		CppCFData(const CppCFData& copy_source);
		CppCFData(const void* data,unsigned size);
		virtual ~CppCFData();
		
		virtual unsigned getLength() const;
		virtual unsigned size() const; // getLengthsize͓B
		virtual CppCFData& setLength(unsigned len);
		virtual CFDataRef getData() const;
		virtual CFDataRef getCloneOfData() const; // CppCFDatãbvĂ̂ł͂ȂARs[CFDataRefԂ܂B
		
		virtual CppCFData& append(SInt16 data);
		virtual CppCFData& append(UInt16 data);
		virtual CppCFData& append(CFDataRef data);
		virtual CppCFData& append(const CppCFData& data);
		virtual CppCFData& append(const void* data,unsigned size);
		
		virtual SInt16 getSInt16(unsigned pos) const; // posoCgڂ2oCgSInt16ƂĎ擾B
		virtual UInt16 getUInt16(unsigned pos) const; // posoCgڂ2oCgUInt16ƂĎ擾B
		virtual const char* getDataPtr(unsigned begin_pos) const; // posoCgڂ̃|C^ԂB
		virtual CppCFData& copyData(unsigned pos,unsigned size,void* dest) const; // posoCgڂsizeoCgdestɃRs[B
		
		 // start_pos͊܂ނend_pos͊܂܂Ȃf[^쐬ĕԂB
		virtual CppCFData subdata(unsigned start_pos) const;
		virtual CppCFData subdata(unsigned start_pos,unsigned end_pos) const;
		
		virtual CppCFData& operator=(const CppCFData& data);
		
		virtual CppCFData& operator+=(SInt16 data);
		virtual CppCFData& operator+=(UInt16 data);
		virtual CppCFData& operator+=(const CppCFData& data);
};