/*
	$Id: CppMessagePortConnection.cpp,v 1.3 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CppMessagePortConnection.h"

CppMessagePortConnection::CppMessagePortConnection()
	:portRef(NULL)
{
	
}

CppMessagePortConnection::CppMessagePortConnection(const CppCFString& port_name) throw(std::exception)
{
	portRef = CFMessagePortCreateRemote(NULL,port_name.getString());
	if (portRef == NULL) // s
	{
		throw std::exception();
	}
}

CppMessagePortConnection::CppMessagePortConnection(const CppMessagePortConnection& copy_src)
{
	// s{ӂAconsttȂƐFXƂ܂ȂB
	CFMessagePortRef src_port = const_cast<CFMessagePortRef>(copy_src.portRef);
	
	CFRetain(src_port);
	portRef = src_port;
}

CppMessagePortConnection::~CppMessagePortConnection()
{
	if (portRef != NULL) CFRelease(portRef);
}

CppCFData CppMessagePortConnection::send(SInt32 message_id) throw(std::exception)
{
	return send(message_id,CppCFData());
}

CppCFData CppMessagePortConnection::send(SInt32 message_id,const CppCFData& attachment) throw(std::exception)
{
	if (portRef == NULL)
	{
		throw std::exception();
	}
	
	CFDataRef replyData = NULL;
	CppCFData result;
	
	if (CFMessagePortSendRequest(
				portRef,message_id,attachment.getData(),
				10,10,kCFRunLoopDefaultMode,&replyData) != kCFMessagePortSuccess)
	{
		throw std::exception();
	}
	
	if (replyData != NULL)
	{
		result = replyData;
		CFRelease(replyData);
	}
	return result;
}

CppMessagePortConnection& CppMessagePortConnection::operator=(CppMessagePortConnection& copy_src)
{
	if (portRef != NULL) CFRelease(portRef);
	
	// s{ӂAconsttȂƐFXƂ܂ȂB
	CFMessagePortRef src_port = const_cast<CFMessagePortRef>(copy_src.portRef);
	
	CFRetain(src_port);
	portRef = src_port;
	
	return *this;
}