/*
	$Id: DMDictionary.cpp,v 1.3 2002/11/29 12:23:12 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
    Directory ManegerΉ@2002.09.25 Shin_ichi Abe.
*/
#include <Carbon/Carbon.h>
#include <fstream>
#include "DMDictionary.h"
#include "StringTokenizer.h"
#include "CppCFData.h"
using namespace util;

#if 0
#	define D_PRINTF printf
#else
#	define D_PRINTF if(0)printf
#endif

DMDictionary::DMDictionary(const vector<CppCFString>& kotoeri_dic_file)
    : numID(0), numRef(0)
{ 
    for (vector<CppCFString>::const_iterator ite = kotoeri_dic_file.begin();ite != kotoeri_dic_file.end();ite++)
	{
/*        D_PRINTF("KOTOERI_DIC: %s\n",ite->c_str());
        CppCFString path(ite->c_str(),kCFStringEncodingShiftJIS);*/
        CppCFString path( ite->getString() );
        openDictionary( path );
	}
}

DMDictionary::~DMDictionary()
{

}

void DMDictionary::changeDictionaryFile(const vector<CppCFString>& kotoeri_dic_file)
{
    closeDictionary();

    for (vector<CppCFString>::const_iterator ite = kotoeri_dic_file.begin();ite != kotoeri_dic_file.end();ite++)
	{
/*        D_PRINTF("KOTOERI_DIC: %s\n",ite->c_str());
        CppCFString path(ite->c_str(),kCFStringEncodingShiftJIS);*/
        CppCFString path( ite->getString() );
        openDictionary( path );
	}
}

void DMDictionary::save(bool& terminate_flag)
{
	/*	Ƃ̎QƂ邾Ȃ̂ŁAۑȂB	*/
}

vector<CppCFString> DMDictionary::findWithoutOkuri(const CppCFString& query)
{
    // ݂Ȃ΋vectorԂB
    D_PRINTF("KOTOERI_DIC - QUERY: %s\n",query.toCString(kCFStringEncodingShiftJIS));
    //1ȂB
    if( numRef == 0 ){
        vector<CppCFString> empty;
        return empty;
    }
    return findRecord( query );
}

vector<OkuriganaEntry> DMDictionary::findWithOkuri(const CppCFString& root)
{
	// ݂Ȃ΋vectorԂB
	vector<OkuriganaEntry> empty;
    return empty;
}

vector<CppCFString> DMDictionary::findCompletions(const CppCFString& query)
{
	// ݂Ȃ΋vectorԂB
    vector<CppCFString> empty;
    return empty;
}

void DMDictionary::registerWord(const CppCFString& index,const CppCFString& okuri,const CppCFString& kanji)
{
	// 艼LB
    /*	Ƃ̎QƂ邾Ȃ̂ŁAo^oȂB	*/
}

void DMDictionary::registerWord(const CppCFString& index,const CppCFString& kanji)
{
    // 艼Ȃ
    /*	Ƃ̎QƂ邾Ȃ̂ŁAo^oȂB	*/
}

void DMDictionary::removeWord(const CppCFString& index,const CppCFString& okuri,const CppCFString& kanji)
{
	// 艼
	/*	Ƃ̎QƂ邾Ȃ̂ŁA폜oȂB	*/
}

void DMDictionary::removeWord(const CppCFString& index,const CppCFString& kanji)
{
    // 艼Ȃ
	/*	Ƃ̎QƂ邾Ȃ̂ŁA폜oȂB	*/
}

void DMDictionary::openDictionary( const CppCFString& fpath )
{
    OSStatus status;
    
    CFStringRef strRef  = fpath.getString();
    FSSpec spec;
    
	DCMDictionaryID dictionaryID;
	DCMDictionaryRef dictionaryRef;
	
    status = FilePathToFSSpec( strRef, &spec );
    
	status = DCMRegisterDictionaryFile( (const FSSpec *)&spec, &dictionaryID );
	
	if ( status == noErr)
    {
        dicID[numID++] = dictionaryID;
        
		status = DCMOpenDictionary( dictionaryID, 0, 0, &dictionaryRef);
	}
    
    if( status == noErr )
        dicRef[numRef++] = dictionaryRef;
    
    D_PRINTF("KOTOERI_DIC - OPEN\n");
}

void DMDictionary::closeDictionary()
{
    OSStatus status;
    
    for (int i = 0 ; i < numID ; i++)
    {
        status = DCMCloseDictionary(dicRef[i]);
    }
    for (int i = 0 ; i < numRef ; i++)
    {
        status = DCMUnregisterDictionary(dicID[i]);
    }
    
    numID = numRef = 0;
    
    D_PRINTF("KOTOERI_DIC - CLOSE\n");
}

bool DMDictionary::checkDictionary( const CFStringRef fpath )
{
    OSStatus status;
    
    DCMDictionaryID dictionaryID;
	DCMDictionaryRef dictionaryRef;
    FSSpec spec;
    
    status = FilePathToFSSpec( fpath, &spec );
    
    if( status != noErr)
        return false;
        
	status = DCMRegisterDictionaryFile( (const FSSpec *)&spec, &dictionaryID );
	
	if( status != noErr)
        return false;

    status = DCMOpenDictionary( dictionaryID, 0, 0, &dictionaryRef);
	
    
    if( status != noErr ){
        status = DCMCloseDictionary(dictionaryRef);
        return false;
    }
    
    status = DCMCloseDictionary(dictionaryRef);
    status = DCMUnregisterDictionary(dictionaryID);
    
    return true;
}

vector<CppCFString> DMDictionary::findRecord( const CppCFString& query )
{
    OSStatus status;
    
    DCMFieldTag	dataFieldTagList[] = { kDCMJapaneseHyokiTag };
    
    DCMFoundRecordIterator	iterator;
    
    CFStringRef strRef  = query.getString();
	ByteCount length = CFStringGetLength( strRef ) * sizeof(UniChar);
	const UniChar*	textPtr = CFStringGetCharactersPtr( strRef );

    vector<CppCFString> result;

    for (int i = 0 ; i < numRef ; i++)
    {
        // R[h
        status = DCMFindRecords( dicRef[i],						// Dictionary reference
                                    kDCMJapaneseYomiTag, 		// key field tag
                                    length,						// key data length
                                    textPtr,					// key data
                                    kDCMFindMethodExactMatch,	// find method
                                    1,							// number of data field
                                    dataFieldTagList, 			// data field tag list
                                    0, 0, 						// search all records
                                    &iterator); 				// found result
        if( status != noErr )
            continue;
        
        while( true ){
            AERecord dataList;
            DCMUniqueID uniqueID;
            ByteCount keySize;
            UniChar foundKeyStr[kMaxKanjiLengthInAppleJapaneseDictionary];
    
            Size actualSize;
            DescType actualType;
            UniChar dataBuffer[kMaxKanjiLengthInAppleJapaneseDictionary];
            
            // Get one record from result list
            status = DCMIterateFoundRecord( iterator, 									// found result
                                            kMaxKanjiLengthInAppleJapaneseDictionary, 	// key buffer size
                                            &keySize, 									// actual found key size
                                            foundKeyStr, 								// found key data
                                            &uniqueID, 									// j[NID
                                            &dataList); 								// AERecordf[^

            if ( status != noErr) break;
            // Get one data from AERecord
            status = AEGetKeyPtr( &dataList, 
                                    kDCMJapaneseHyokiTag, 'utxt',
                                    &actualType,
                                    &dataBuffer, kMaxKanjiLengthInAppleJapaneseDictionary, &actualSize);
            // Dispose data AERecord
            AEDisposeDesc( &dataList);

            CppCFData data((const char*)dataBuffer,actualSize);

           // CppCFString foundStr(dataBuffer, actualSize / sizeof(UniChar));
            CppCFString foundStr(data.getData());

            char buf[kMaxKanjiLengthInAppleJapaneseDictionary*4];
			bool f;
			
			f = CFStringGetCString ( foundStr.getString(), buf, sizeof(buf), kCFStringEncodingShiftJIS );
            
            if(strlen( buf ) > 0 ){
                result.push_back(foundStr);
            }
        }
	}
    
    D_PRINTF("KOTOERI_REPLY: %s\n",join(' ',result).toCString(kCFStringEncodingShiftJIS));

    return result;
}

OSErr FilePathToFSSpec( CFStringRef filePath, FSSpec *apSpec )
{

    CFURLRef cfUrl = CFURLCreateWithFileSystemPath( kCFAllocatorDefault, 
                                                    (CFStringRef) filePath, kCFURLPOSIXPathStyle, false );
    FSRef  fileRef;
    OSErr  err = noErr;

    if( CFURLGetFSRef( cfUrl, &fileRef ) ) {
        err = FSGetCatalogInfo( &fileRef, kFSCatInfoNone, NULL, NULL, apSpec, NULL );
        if ( err ) return( err );
    }
    
    CFRelease( cfUrl );
    return( err );
}


