/*
	$Id: InputMode.h,v 1.12 2003/05/14 12:03:14 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once

#include <Carbon/Carbon.h>
#include "CppCFString.h"
#include "BIM.h"

const UniChar kIgnoreThis = 0x01;
// ChildInputMode::getStringToDisplay()ygetStringToFix()̕ԂƁAe͉XVsȂB
const UniChar kCaret = 0x02;
// ChildInputMode::getStringToDisplay()̖߂lɂ̕ƁAɃLbguB
//const unsigned char kCj = 0x0a;
// C-j\B
//const unsigned char kCq = 0x11;
// C-q\B
//const unsigned char kCg = 0x07;
// C-g\B

class InputMode
{
	public:
		static const int ARROW_LEFT = 0;
		static const int ARROW_UP = 1;
		static const int ARROW_RIGHT = 2;
		static const int ARROW_DOWN = 3;
		
		// ͂ꂽɌĂ΂B̌AgetStringToFix()getStringToDisplay()Ă΂B
		// trueԂꂽA̒getStringFix()Ă΂AԂꂽ񂪊m肳B
		virtual bool handleInput(unsigned char inputChar) = 0;
		
		// BackSpace͂ꂽɌĂ΂B
		// ԂωȂfalseԂBfalseԂƖ{ꕶB
		virtual bool handleBackSpace() = 0;
		
		// return/enterꂽɌĂ΂B
		// ꂪtrueԂ牽ȂBfalseԂgetStringFix()Ă΂Am肳ꂽA{sB
		virtual bool handleReturn() = 0;
		
		// L[ꂽɌĂ΂B
		// kindɂ͒萔InputMode.ARROW_*nB
		// ԂωȂfalseԂBfalseԂgetStringFix()Ă΂Am肳ꂽAۂ̃J[\B
		virtual bool handleArrow(int kind) { return false; }
		
		// C-gꂽɌĂ΂BtrueԂAquaSKKC-g򂢁AfalseȂ킸ɃCxg߂B
		virtual bool handleCg() { return false; }
		
		// TabꂽɌĂ΂BtrueԂAquaSKKTab򂢁AfalseȂ킸ɃCxg߂B
		virtual bool handleTab() { return false; }
		
		// C-yꂽɌĂ΂BtrueԂAquaSKKC-y򂢁AfalseȂ킸ɃCxg߂B
		virtual bool handleCy() { return false; }
		
		// ͂f鎞ɌĂ΂B
		// ꂪĂ΂ꂽAgetStringToFix()Ă΂Am肳B
		virtual void terminate() {}
};
