/*  -*- c++ -*-
    $Id: SKKServer.h,v 1.11 2003/06/22 10:56:40 phonohawk Exp $
    ---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include <string>
#include <vector>
#include "CppCFString.h"
#include "SKKDictionary.h"
#include "DMDictionary.h"
using namespace std;

/*
	KvƂSingletonłB
	gpOsharedServer(string,string,string)Ă΂ȂĂ͂ȂȂB
	
	ĉC܂B͂Ŏ̏ꏊ擾̂Ǝvc
*/

class SKKServer {
protected:
  SKKDictionary base_dic;
  SKKDictionary sub_dic;
  SKKDictionary user_dic;
  DMDictionary kotoeri_dic;
  vector<Dictionary*> all_dics;
  
  SKKServer(const string& base_dic_file,const string& sub_dic_file,const string& user_dic_file,const vector<CppCFString>& kotoeri_dic_file);
  virtual ~SKKServer();
  
public:
  static SKKServer& sharedServer(const string& base_dic_file,const string& sub_dic_file,const string& user_dic_file,const vector<CppCFString>& kotoeri_dic_file);
  static SKKServer& sharedServer();
  
  virtual SKKDictionary& getBaseDic();
  virtual SKKDictionary& getSubDic();
  virtual SKKDictionary& getUserDic();
  virtual DMDictionary& getKotoeriDic();
  
  virtual CppCFString skkserv_style_search(const CppCFString& query); // NOT FOUNDȂ̕ԂB
  virtual CppCFString search(const CppCFString& query); // NOT FOUNDȂ̕ԂB
  virtual void registerToUserDic(const CppCFString& query);
  virtual void removeFromUserDic(const CppCFString& query);
  virtual CppCFString searchCompletions(const CppCFString& query); // NOT FOUNDȂ̕ԂB
  
  virtual void parseAllDictionaries(); // SĂ̖̎p[XGgp[XBTuXbhĂԂƁB
};

void removeRedundantItems(vector<CppCFString>& candidates);
