/*
	$Id: ServerConnection.cpp,v 1.3 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "ServerConnection.h"
#include "BIMClientServer.h"

ServerConnection::ServerConnection()
	:CppMessagePortConnection()
{

}

ServerConnection::ServerConnection(const CppCFString& port_name) throw(std::exception)
	:CppMessagePortConnection(port_name)
{

}

ServerConnection::ServerConnection(const ServerConnection& copy_src)
	:CppMessagePortConnection(copy_src)
{

}

ServerConnection::~ServerConnection()
{

}

CppCFData ServerConnection::createHeader()
{	
	BasicMessageHeader header;
	GetCurrentProcess(&header.fProcessSerialNumber);
	
	return CppCFData(&header,sizeof(BasicMessageHeader));
}

CppCFData ServerConnection::send(SInt32 message_id) throw(std::exception)
{
	return CppMessagePortConnection::send(message_id,createHeader());
}

CppCFData ServerConnection::send(SInt32 message_id,const CppCFData& attachment) throw(std::exception)
{
	CppCFData data_to_send(createHeader());
	data_to_send += attachment;
	
	return CppMessagePortConnection::send(message_id,data_to_send);
}