/*
	$Id: WordRegisterMode.h,v 1.9 2003/05/14 12:03:14 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include "InputMode.h"
#include "CppCFString.h"
#include "ParentInputMode.h"
#include "IMSessionInputMode.h"

class WordRegisterMode : public ParentInputMode
{
	public:
		// title̗Fuɂ*vAu͂v
		// ownerRegistrationStarterpĂȂ΂ȂȂB
		WordRegisterMode(class ChildInputMode& owner,const CppCFString& word);
		virtual ~WordRegisterMode() {}
		
		virtual bool handleReturn();
		virtual bool handleBackSpace();
		virtual bool handleArrow(int kind);
		virtual bool handleCg();
		virtual bool handleCy();
		virtual bool handleTab();
		
		virtual void fix(const CppCFString& str_to_fix);
		virtual void display(const CppCFString& str_to_display);
		
		virtual void redisplay();
		
		virtual CppCFString getContent() const;
	
	protected:
		class ChildInputMode* owner;
		CppCFString title;
		CppCFString buffer;
		unsigned caret;
		
		IMSessionInputMode* imsession_input_mode;
};
