/*
	$Id: StringUtils.cpp,v 1.3 2002/11/29 12:23:04 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "StringUtils.h"
#include <ctype.h>
using namespace std;

string util::toLower(const string& src)
{
	string result;
	
	const unsigned int len = src.length();
	for (unsigned int i = 0;i < len;i++)
	{
		result.append(1,
			static_cast<char>(
				::tolower(static_cast<int>(src[i]))
					));
	}
	return result;
}

string util::join(const char delimitor,const vector<string>& vec)
{
	string result;
	
	for (vector<string>::const_iterator ite = vec.begin();ite != vec.end();ite++)
	{
		result += *ite + delimitor;
	}
	
	if (result.length() > 0)
		return string(result.begin(),result.end()-1);
	else
		return result;
}